import buw.*;

/**
 * example 2: form in a grid (aligned controls)
 * using: Grid (HBoxColumn), TextButton, Input, Label, PasswordInput, Separator & SpinBox
 */

class Example2 {
	public static function main() {
		new Example2();
	}

	var first : Input;
	var last : Input;
	var age : TextSpinBox;
	var password : PasswordInput;

	function new() {
		//this time, the form is a grid with two columns; it is a usefull container for widgets alignement;
		//the first column uses 30% of screen width and is left aligned (cf -1),
		//the second column uses 70% of the screen width (and centered by default):
		var form = new Grid([new HBoxColumn(0.3, -1), new HBoxColumn(0.7)]);

		//by default, inputs use 100% of available width (70% of screen width, since they are put in the second column)
		first = new Input(20);
		last = new Input(20);

		//widgets are stacked line by line, from left to right:
		form.pack(new Label("Firstname:"));
		form.pack(first);
		//third packing is for the second line (since there are two columns):
		form.pack(new Label("Lastname:"));
		form.pack(last);

		age = new TextSpinBox("yo", 18, 1, 99); //label, value, min, max
		age.value = 100; //to demonstrate how to change spinbox value; will be set to 50 because 100 is off limits
		form.pack(age);
		form.pack(new Separator());

		password = new PasswordInput("", 20);
		form.pack(new Label("Password:"));
		form.pack(password);

		form.pack(new Separator());
		form.pack(new TextButton(onClick, "OK"));
		Screen.display(form);
	}

	function onClick(w : TextButton) {
		Sys.println(first.value + " " + last.value + " " + age.value + "yo; password=" + password.value); //access inputs and spinboxes values
	}
}
