import buw.*;

/**
 * example 3b: list view using renderer
 * using: VBox, ListView, Separator, Label & TextButton
 */

typedef Book = {
	var author : String;
	var title : String;

	//no required toString method this time
}

class Example3b {
	public static function main() {
		new Example3b();
	}

	var booksList : ListView<Book>;

	function new() {
		var rootWindow = new VBox();
		rootWindow.pack(new TextButton(onAddBooksClick, "Add books"));
		Screen.display(rootWindow);
		rootWindow.pack(new Separator());

		//to create a list view, one must tell how to render an item, and eventually tell what to do when an item is clicked:
		booksList = new ListView(renderBook, onBookClick);
		rootWindow.pack(booksList);
	}

	function onAddBooksClick(w : TextButton) {
		var books : Array<Book> = new Array();
		books.push({ title : "Les misérables", author : "Victor Hugo" });
		books.push({ title : "20 000 lieues sous les mers", author : "Jules Verne" });
		booksList.source = books;
	}

	//the render function is given an item as a parameter; the returned widget will be displayed by the list view;
	//this function is called once per widget in the item collection:
	function renderBook (b : Book) : Widget {
		//the returned widget is here a label:
		return new Label(b.title + " - " + b.author);
		//it could be something more complex like an horizontal box with an image and a label for example
	}

	function onBookClick(b : Book) {
		Sys.println(b.title);
	}
}
